/*
Bouncing 'Hi' Program by ssjx

This program uses the CybornOS system created by CyBorn (Gotthardt)
*/


#include "2245s.h"
#include "lowlevel.h"

//
// Uses a chunky to planar type system to draw the display,
// it's slower than using normal sprites but i was
// curious to see how well it would work.
//
// This method is used a lot on the Amiga. 
//

void c2p_draw(unsigned char *,unsigned char *);
void c2p_sprite8(int,int, char *,unsigned char *);

//
// This function takes a 160x100x8bpp and converts it to 160x100x2bpp
//

void c2p_draw(unsigned char *in,unsigned char *out)
{
unsigned char p1,p2,p3,p4;
int ct=0,cy=0,i,j;

for(j=0;j<100;j++)
{
	for(i=0;i<40;i++)
	{	
	p1=in[ct++];
	p2=in[ct++];
	p3=in[ct++];
	p4=in[ct++];
	
	out[cy++]=(p1<<6)+(p2<<4)+(p3<<2)+p4;
	}
}

}

// Draw an 8x8 sprite to the chunky display

void c2p_sprite8(int x,int y,char *spr,unsigned char *out)
{
int i,j,spos=0,py;

for(j=0;j<8;j++)
{
py=(y+j)*160;
for(i=0;i<8;i++)
{
out[py+x+i]=spr[spos++];
}
}

}

char hi[]={
1,0,0,1,0,0,0,0,
1,0,0,1,0,0,1,0,
1,0,0,1,0,0,0,0,
1,1,1,1,0,1,1,0,
1,0,0,1,0,0,1,0,
1,0,0,1,0,0,1,0,
1,0,0,1,0,1,1,1,
2,2,2,2,2,2,2,2,
};


int main(int argc, char *argv[])
{
static unsigned char dis[4000]; //actual screen
static unsigned char buf[16000]; // buffer

int bx=10,by=10,xdir=-1,ydir=1,cc;

_displayclear(dis);
_displaynow(dis);

for(;;)
{
// clear our chunky display (could really use a memset function...)

for(cc=0;cc<16000;cc++)
{
buf[cc]=0;
}


// draw our sprites

c2p_sprite8(bx,by,hi,buf); // bouncing
c2p_sprite8(50,50,hi,buf); // not bouncing..


// convert out 8bit display 
c2p_draw(buf,dis);

//update our sprite positions
bx+=xdir;
by+=ydir;

if ( ((bx+8)>=159) || (bx<=0)){xdir*=-1;}
if ( ((by+8)>=99) || (by<=0)){ydir*=-1;}


// finally draw everything!

      _displaynow(dis);
}

return 1;
}
